define("epi-cms/project/command/EditProjectItem", [
    "dojo/_base/declare",

    "epi-cms/contentediting/ContentActionSupport",

// Parent class
    "./_ProjectCommand",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.editprojectitem"
],
function (
    declare,
    ContentActionSupport,
// Parent class
    _ProjectCommand,
// Resources
    res
) {
    return declare([_ProjectCommand], {
        // summary:
        //      A command for switching to the edit view for a project item.
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "menuWithSeparator",

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPen",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.label,

        modelPropertyToWatch: "selectedProjectItem",

        _execute: function() {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected

            this.model.requestContextChange(this.model.selectedProjectItem.contentLink);
        },

        _setCanExecute: function() {
            // summary:
            //      This command is able to execute if there is a selected project item.
            // tags:
            //      protected

            var canExecute = !!(this.model && this.model.selectedProjectItem && this.model.selectedProjectItem.contentLink);

            this.set("canExecute", canExecute);
        }
    });
});
